/*
                ***** ALLOC2D.H *****

Include file for dynamic 2-D array allocation.

Author: John M. Weiss, Ph.D.
Written 07/03/91.

Modifications:
10/14/91 - Use far pointers explicitly in 2-D memory allocation routines
    so that they are not crippled by the small memory model.
06/20/93 - Rewrite for both Turbo C and DJGPP.
*/

#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#define far
#define huge
#endif

void far **alloc2D (int nrows, int ncols, int size);
void free2D (void far **array);

#define Calloc2D(nrows, ncols)  ((char far **) alloc2D(nrows, ncols, sizeof(char)))
#define SCalloc2D(nrows, ncols) ((signed char far **) alloc2D(nrows, ncols, sizeof(char)))
#define UCalloc2D(nrows, ncols) ((unsigned char far **) alloc2D(nrows, ncols, sizeof(char)))
#define Ialloc2D(nrows, ncols)  ((int far **) alloc2D(nrows, ncols, sizeof(int)))
#define Ualloc2D(nrows, ncols)  ((unsigned far **) alloc2D(nrows, ncols, sizeof(unsigned)))
#define Salloc2D(nrows, ncols)  ((short far **) alloc2D(nrows, ncols, sizeof(short)))
#define USalloc2D(nrows, ncols) ((unsigned short far **) alloc2D(nrows, ncols, sizeof(unsigned short)))
#define Lalloc2D(nrows, ncols)  ((long far **) alloc2D(nrows, ncols, sizeof(long)))
#define ULalloc2D(nrows, ncols) ((unsigned long far **) alloc2D(nrows, ncols, sizeof(unsigned long)))
#define Falloc2D(nrows, ncols)  ((float far **) alloc2D(nrows, ncols, sizeof(float)))
#define Dalloc2D(nrows, ncols)  ((double far **) alloc2D(nrows, ncols, sizeof(double)))

#define Free2D(array)           free2D((void far **) array)

