#ifndef TEXTUREDEF
#define TEXTUREDEF

#include "image.h"
#include "vect.h"

typedef struct texture {
	int xsize;
	int ysize;
	int bw;
	int bpp;
	unsigned char **r;
	unsigned char **g;
	unsigned char **b;
} TEXTURE;

/* PYRAMIDHEIGHT gives the number of levels in the mip map. */
#define PYRAMIDHEIGHT	16	

typedef struct mipmap {
	int levels;
	TEXTURE	 *maps[PYRAMIDHEIGHT];
} MIPMAP;

float frand();
float xsin();
float fnoise3();
float onewrap();
TEXTURE *tmopen();
TEXTURE *tmalloc();
float noisefunc();
float wave();
float ocean();
float turbulence();
float ease();
MIPMAP *mipopen();

#endif TEXTUREDEF
