/** 
 ** HIXCOLOR.H
 **
 **  Copyright (C) 1993, David Max
 **    185 West End Ave Apt 3H
 **    New York, NY 10023
 **    max@cs.nyu.edu
 **
 **  This file is distributed under the terms listed in the document
 **  "copying.cb", available from the author at the address above.
 **  A copy of "copying.cb" should accompany this file; if not, a copy
 **  should be available from where this file was obtained.  This file
 **  may not be distributed without a verbatim copy of "copying.cb".
 **  You should also have received a copy of the GNU General Public
 **  License along with this program (it is in the file "copying");
 **  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 **  Cambridge, MA 02139, USA.
 **
 **  This program is distributed in the hope that it will be useful,
 **  but WITHOUT ANY WARRANTY; without even the implied warranty of
 **  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **  GNU General Public License for more details.
 **/

#ifndef __HIXCOLOR_H__
#define __HIXCOLOR_H__

/****************************************************************************
   24 bit true color defs and prototypes
****************************************************************************/
#define pixel_24 unsigned char

#define _MaxX_24 640
#define _MaxY_24 480

void GrSetMode_24(void);
void GrPlot24(int x, int y, pixel_24 red, pixel_24 grn, pixel_24 blu);
void GrScanLine24(int y, int x1, int x2, pixel_24 pix[]);
void GrBitBlit24(int x1, int y1, int x2, int y2, pixel_24 pix[]);
void GrLine24(int x1, int y1, int x2, int y2,
              pixel_24 red, pixel_24 grn, pixel_24 blu);

/****************************************************************************
   15 bit hi color defs and prototypes
****************************************************************************/
#define pixel_HI unsigned short int

#define _MaxX_HI 800
#define _MaxY_HI 600

void GrSetMode_HI(void);
void GrPlotHI(int x, int y, pixel_24 red, pixel_24 grn, pixel_24 blu);
void GrPlotHI2(int x, int y, pixel_HI c);
void GrLineHI(int x1, int y1, int x2, int y2,
              pixel_24 red, pixel_24 grn, pixel_24 blu);
void GrLineHI2(int x1, int y1, int x2, int y2, pixel_HI c);

#endif /* __HIXCOLOR_H__ */
