/* 
     A new delay() function for DJGPP

      I've written a delay() function that uses a BIOS service that produces
delays using system timers. It's a delay.s file. It's also necessary to include
a prototype in stdio.h:

void delay (unsigned int milliseconds);

     The file included (libsrc/c/dos/delay.s) replaces libsrc/c/dos/delay.c.
The advantage is that multitaskers can detect this call and use the CPU time
for other processes. I hope you find it useful. Regards,

								Javier

Date: Thu, 3 Jun 93 21:13:43 +0200
From: javier@orion.auto.isa.cie.uva.es (Javier Achirica)

*/

        .globl  _delay
_delay:
        pushl   %edi
        pushl   %esi
        pushl   %ebx
        movl    16(%esp),%ebx
        jmp     L2
L4:
        movb    $0x86,%ah
        movw    $65535,%cx
        movw    $65240,%dx
        int     $0x15
        addl    $-4294967,%ebx
L2:
        cmpl    $4294967,%ebx
        ja      L4
L3:
        movl    %ebx,%eax
        sall    $5,%eax
        subl    %ebx,%eax
        leal    (%ebx,%eax,4),%eax
        leal    0(,%eax,8),%ebx

        movl    %ebx,%ecx
        shrl    $16,%ecx
        movw    %bx,%dx
        movb    $0x86,%ah
        int     $0x15
        popl    %ebx
        popl    %esi
        popl    %edi
        ret
