/* $Id$ */
/*
 * fvwmdos.c
 *
 * Fvwm 1.18d functions to be used with Xlibemu.
 */
#include "fvwm.h"

#include <sys/types.h>
#include <sys/time.h>

#ifdef MSDOS

extern XEvent Event;
extern char *config_file;
extern void My_XNextEvent(Display *dpy, XEvent *event);
extern void DispatchEvent(void);
extern int fvwm_main(int, char **);

static int initialized = 0;


void HandlePendingEvents(void)
{
  while (TRUE)
    {
      Event.type = 0;
      My_XNextEvent(dpy, &Event);
      if (Event.type == 0)
	break;
      DispatchEvent ();
    }
}


#ifndef NO_GO32INFO
#include "go32info.c"
#endif

int
fvwm (void)
{
  char *argv[2];

  if (! initialized) 
    {
      config_file = "_fvwmrc";
      argv[0] = "fvwm";
      argv[1] = 0;
      fvwm_main (1, argv);
      initialized = 1;
    }
  HandlePendingEvents ();
#ifndef NO_GO32INFO
  go32info ();
#endif
  return 0;
}

#ifndef HAVE_FCNTL
int fcntl(int fd, int mode, ...)
{
  return 0;
}
#endif

struct itimerval {
  struct timeval it_value;
  struct timeval it_interval;
};

#ifndef HAVE_SETITIMER
int setitimer(int timer,struct itimerval *value, void *ptr)
{
  return 0;
}
#endif

#ifndef HAVE_GETITIMER
int getitimer(int timer,struct itimerval *value)
{
  value->it_value.tv_usec = 0;
  value->it_value.tv_sec = 0;
  return 0;
}
#endif


#endif /* MSDOS */
