


     RCSCLEAN(1L)	     Purdue University		  RCSCLEAN(1L)



     NAME
	  rcsclean - clean up working files

     SYNOPSIS
	  rcsclean [ -rrev ] [ -qrev ] file...

     DESCRIPTION
	  Rcsclean removes working files that were checked out and
	  never	modified.  For each file given,	rcsclean compares the
	  working file and a revision in the corresponding RCS file.
	  If it	finds no difference, it	removes	the working file, and,
	  if the revision was locked by	the caller, unlocks the
	  revision.

	  A file name ending in	',v' is	an RCS file name, otherwise a
	  working file name. Rcsclean derives the working file name
	  from the RCS file name and vice versa, as explained in
	  co(1L).  Pairs consisting of both an RCS and a working file
	  name may also	be specified.

	  Rev specifies	with which revision the	working	file is
	  compared.  If	rev is omitted,	rcsclean compares the working
	  file with the	latest revision	on the default branch
	  (normally the	highest	branch on the trunk).  The option -q
	  suppresses diagnostics.

	  Rcsclean is useful for "clean" targets in Makefiles.	Note
	  that rcsdiff(1L) prints out the differences.	Also, ci(1L)
	  normally asks	whether	to check in a file if it was not
	  changed.

     EXAMPLES
	  The command

	       rcsclean	*.c *.h

	  removes all working files ending in ".c" or ".h" that	were
	  not changed since their checkout.

     DIAGNOSTICS
	  The exit status is 0 if there	were no	differences during the
	  last comparison or if	the last working file did not exist, 1
	  if there were	differences, and 2 if there were errors.

     IDENTIFICATION
	  Author: Walter F. Tichy, Purdue University, West Lafayette,
	  IN, 47907.
	  Revision Number: 1.2 ; Release Date: 89/05/02	.
	  Copyright c 1982, 1988, 1989 by Walter F. Tichy.

     SEE ALSO
	  co(1L), ci(1L), ident(1L), rcs(1L), rcsdiff(1L),



     Page 1					     (printed 8/18/90)






     RCSCLEAN(1L)	     Purdue University		  RCSCLEAN(1L)



	  rcsintro(1L),	rcsmerge(1L), rlog(1L),	rcsfile(5L).






















































     Page 2					     (printed 8/18/90)



