#include "HEADERS.h"
#include "srgplocal.h"

/** THIS FILE IS FOR GRX IMPLEMENTATION ONLY
**/

void SRGP__initColor(int requested_planes)
{
	int numcolors = GrNumColors();
	int numplanes,i;

	for(numplanes = 1; (1 << numplanes) < numcolors; numplanes++);
	if(requested_planes > 0) {
	    if(requested_planes < numplanes) numplanes = requested_planes;
	}
	srgp__available_depth	= numplanes;
	srgp__base_colorindex	= 0;
	srgp__application_depth = numplanes;
	numcolors = 1 << numplanes;
	srgp__max_pixel_value	= numcolors - 1;
	srgp__color_lookup_table = malloc(sizeof(int) * (numcolors + 1));
	if(srgp__color_lookup_table == NULL) {
	    SRGP__error(ERR_MALLOC);
	    return;
	}
	SRGP_WHITE = 0;
	SRGP_BLACK = 1;
	COLORINDEX(SRGP_WHITE) = GrAllocColor(255,255,255);
	COLORINDEX(SRGP_BLACK) = GrAllocColor(0,0,0);
	/* allocate once more, this way 'GrWhite' and 'BrBlack' */
	/* will not be overwritten !! */
	GrAllocColor(255,255,255);
	GrAllocColor(0,0,0);
	for(i = 2; i < numcolors; i++) COLORINDEX(i) = GrNOCOLOR;
}

void SRGP_loadColorTable(
    int startentry,int count,
    unsigned short *redi,
    unsigned short *greeni,
    unsigned short *bluei)
{
	while((--count >= 0) && (startentry <= srgp__max_pixel_value)) {
	    if(COLORINDEX(startentry) != GrNOCOLOR) GrFreeColor(COLORINDEX(startentry));
	    COLORINDEX(startentry) = GrAllocColor(*redi++ >> 8,*greeni++ >> 8,*bluei++ >> 8);
	    startentry++;
	}
}

void SRGP_inquireColorTable(
    int startentry,int count,
    unsigned short *redi,
    unsigned short *greeni,
    unsigned short *bluei)
{
	int r,g,b;

	while((--count >= 0) && (startentry <= srgp__max_pixel_value)) {
	    GrQueryColor(COLORINDEX(startentry),&r,&g,&b);
	    *redi++   = r << 8;
	    *greeni++ = g << 8;
	    *bluei++  = b << 8;
	    startentry++;
	}
}

