#include "HEADERS.h"
#include "srgplocal.h"

/**
 ** GRX VERSION OF state.c
 **   This contains no conditionally compiled code because it should be used
 **   only in the GRX version.
 **/
void SRGP__initGraphicsDevice(char *name,int requested_planes,boolean debugasap)
{
	int colors;
	int width,height;
	int xpos,ypos;

	width  = srgp__curActiveCanvasSpec.max_xcoord + 1;
	height = srgp__curActiveCanvasSpec.max_ycoord + 1;
	if(requested_planes <= 1)
	    colors = 2;
	if(requested_planes <= 4)
	    colors = 16;
	else if(requested_planes <= 8)
	    colors = 256;
	else colors = 32768;
	GrSetMode(GR_width_height_color_graphics,width,height,colors);
	GrSaveContext(&srgp__curActiveCanvasSpec.grx_canvas);
/*	srgp__curActiveCanvasSpec.max_xcoord = srgp__curActiveCanvasSpec.grx_canvas.gc_xmax;
	srgp__curActiveCanvasSpec.max_ycoord = srgp__curActiveCanvasSpec.grx_canvas.gc_ymax;	*/
	srgp__curActiveCanvasSpec.drawable.bitmap = &srgp__curActiveCanvasSpec.grx_canvas;
	SRGP__initColor(requested_planes);
}

void SRGP__closeGraphicsDevice(void)
{
	GrSetMode(GR_default_text);
}


/** SRGP_refresh -- dummy here **/

void SRGP_refresh(void)
{
	return;
}

/** SRGP_enableSynchronous -- dummy here **/

void SRGP_enableSynchronous()
{
	return;
}

/*!*/

void SRGP_allowResize(boolean allow)
{
	return;
}


