.text

	.align 2,0x90
.globl _AllocLDT
_AllocLDT:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %cx
	movw	$0x0000, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	movl	12(%ebp), %edx
	movw	%ax, (%edx)
	xorl	%eax, %eax
	2:
	leave
	ret

        .align 2,0x90
        .globl _FreeLDT
_FreeLDT:
	pushl	%ebp
	movl	%esp,%ebp

	movw	8(%ebp), %bx
	movw	$0x0001, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
	jmp	2f
	1:
	xorl	%eax, %eax
	2:

	leave
	ret

	.align 2,0x90
.globl _GetBaseAddress
_GetBaseAddress:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %bx
	movw	$0x0006, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	movl	12(%ebp), %edx
	movw	%cx, 2(%edx)
	movw	%dx, (%edx)
	xorl	%eax, %eax
	2:
	leave
	ret

	.align 2,0x90
.globl _SetBaseAddress
_SetBaseAddress:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %bx
	movw	12(%ebp), %dx	/ low word
	movw	14(%ebp), %cx	/ high word
	movw	$0x0007, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	xorl	%eax, %eax
	2:
	leave
	ret

	.align 2,0x90
.globl _SetLimit
_SetLimit:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %bx
	movw	12(%ebp), %dx	/ low word
	movw	14(%ebp), %cx	/ high word
	movw	$0x0008, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	xorl	%eax, %eax
	2:
	leave
	ret

	.align 2,0x90
.globl _GetDescriptor
_GetDescriptor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi

	movw	8(%ebp), %bx
	movl	12(%ebp), %edi
	movw	$0x000b, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	xorl	%eax, %eax
	2:
	popl	%edi
	leave
	ret

	.align 2,0x90
.globl _SetDescriptor
_SetDescriptor:
	pushl	%ebp
	movl	%esp, %ebp
	pushl	%edi

	movw	8(%ebp), %bx
	movl	12(%ebp), %edi
	movw	$0x000c, %ax
	int	$0x31
	jnc	1f
	movl	$-1, %eax
        jmp     2f
        1:
	xorl	%eax, %eax
	2:
	popl	%edi
	leave
	ret

.globl _sgdt
_sgdt:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %eax
	sgdt	(%eax)
	leave
	ret

.globl _sidt
_sidt:
	pushl	%ebp
	movl	%esp, %ebp

	movw	8(%ebp), %eax
	sidt	(%eax)
	leave
	ret

.globl _sldt
_sldt:
	sldt	%eax
	ret

/ void get_segment( selector, offset, to_offset , size )
        .align  2, 0x90
.globl _get_segment
_get_segment:
	pushl	%ebp
	movl	%esp,%ebp
        pushl   %esi
        pushl   %edi
	pushw	%fs

	movw	8(%ebp), %ax
	movw	%ax, %fs
	movl	12(%ebp), %esi
	movl	16(%ebp), %edi
	movl	20(%ebp), %ecx
        shrl    $2, %ecx
	cld
        rep
	fs
        movsl
	movl	20(%ebp), %ecx
        andl    $3, %ecx
        rep
	fs
        movsb

	popw	%fs
	popl	%edi
        popl    %esi
	leave
        ret
