/* $Id: chkeycon.c 1.1 1994/01/30 18:44:03 ulrich Exp $ */
/*
 * X library function XChangeKeyboardControl.
 */
#include "Xlibemu.h"

int
XChangeKeyboardControl(dpy, mask, value_list)
    register Display *dpy;
    unsigned long mask;
    XKeyboardControl *value_list;
{
  int i;

  if (mask & KBKeyClickPercent) {
    i = value_list->key_click_percent;
    if (i < 0)
      _KeyboardState.key_click_percent = 0;	/* default */
    else if (i > 100)
      _KeyboardState.key_click_percent = 100;
    else
      _KeyboardState.key_click_percent = i;
  }
	
  if (mask & KBBellPercent) {
    i = value_list->bell_percent;
    if (i < 0)
      _KeyboardState.bell_percent = 50;		/* default */
    else if (i > 100)
      _KeyboardState.bell_percent = 100;
    else
      _KeyboardState.bell_percent = i;
  }

  if (mask & KBBellPitch) {
    i = value_list->bell_pitch;
    if (i < 0)
      _KeyboardState.bell_pitch = 400;	/* (Hz) default value */
    else
      _KeyboardState.bell_pitch = i;
  }

  if (mask & KBBellDuration) {
    i = value_list->bell_duration;
    if (i < 0)
      _KeyboardState.bell_duration = 100;	/* (ms) default value */
    else
      _KeyboardState.bell_duration = i;
  }
/*
  if (mask & KBLed)
    ??? = value_list->led;

  if (mask & KBLedMode)
    ??? = value_list->led_mode;

  if (mask & KBKey)
    ??? = value_list->key;
*/
  if (mask & KBAutoRepeatMode)
    _KeyboardState.global_auto_repeat = value_list->auto_repeat_mode;
  return 0;
}
