/* $Id: clearar.c 1.1 1994/02/20 17:27:43 ulrich Exp $ */
/*
 * X library function XClearArea.c
 */
#include "Xlibemu.h"

int
XClearArea (Display*		dpy,
	    Window		window, 
	    int			x,
	    int			y,
	    unsigned int	width,
	    unsigned int	height,
	    Bool		exposures)
{
  if (0 == _WCheckWindow (dpy, window, X_ClearArea))
    return 0;
  if (width == 0) width = window->width;
  if (height == 0) height = window->height;

  if (! _WDrawContext ((Drawable) window, None))
    return 0;
  _WDrawRegion (window->background.fillBox,
		x, y, x + width - 1, y + height - 1,
		window->background.fillArg);

  /*
   * for the future draw region should only expose visible
   * rextangles.
   */
  if (exposures) {
    XEvent xe;
    xe.xexpose.type = Expose;
    xe.xexpose.send_event = 0;
    xe.xexpose.display = dpy;
    xe.xexpose.window = window;
    xe.xexpose.x = x;
    xe.xexpose.y = y;
    xe.xexpose.width = width;
    xe.xexpose.height = height;
    xe.xexpose.count = 0;
    _WDispatchEvent (&xe);
  }

  return 1;
}
