/* $Id: lowerwi.c 1.1 1994/02/20 17:37:27 ulrich Exp $ */
/*
 * X library function XLowerWindow.
 */
#include "Xlibemu.h"

int
XLowerWindow (Display *dpy, Window window)
{
  if (0 == _WCheckWindow (dpy, window, X_ConfigureWindow))
    return 0;
  if (window == DefaultRootWindow (dpy))
    return 0;

  if (window->lower_sibling) {
    Window sibling, parent;

    parent = window->parent;
    _WTreeDelete (window);
    _WTreeInsertBot (parent, window);

    if (window->mapped && window->class == InputOutput) {
      for (sibling = window->upper_sibling;
	   sibling != None;
	   sibling = sibling->upper_sibling) {
	if (! sibling->mapped) continue;
	if (! EXTENTCHECK (&sibling->border_port,
			   &window->border_port)) continue;
	_WSetVisibleRegion (sibling);
	_WSetVisibleSubwindows (sibling);
	_WDrawWindow (dpy, sibling, &window->border_port, True);
	_WDrawSubwindows (dpy, sibling, &window->border_port, True);
      }
      _WSetVisibleRegion (window);
      _WSetVisibleSubwindows (window);
    }
  }
  return 1;
}
