/* $Id: misc.c 1.4 1994/02/11 00:48:00 ulrich Exp ulrich $ */
/*
 * misc.c
 *
 * Miscellaneous X library functions.
 */
#include "Xlibemu.h"

int
XFree (void *ptr)
{
  Xfree (ptr);
  return 0;
}

int XSync(
    Display*		display,
    Bool		discard)
{
  if (discard) {
    XEvent xe;

    while (XPending (display)) {
      XNextEvent (display, &xe);
    }
  }
  return 0;
}

int (*XSynchronize(
    Display*		display,
    Bool		onoff
		   ))()
{ return 0; };

int XSetCloseDownMode(
    Display*		display,
    int			close_mode)
{
  return 0;
}

/*
 * This routine can be used to (cheaply) get some memory within a single
 * Xlib routine for scratch space.  It is reallocated from the same place
 * each time, unless the library needs a large scratch space.
 */
char *_XAllocScratch (dpy, nbytes)
	register Display *dpy;
	unsigned long nbytes;
{
	if (nbytes > dpy->scratch_length) {
	    if (dpy->scratch_buffer) Xfree (dpy->scratch_buffer);
	    if (dpy->scratch_buffer = Xmalloc((unsigned) nbytes))
		dpy->scratch_length = nbytes;
	    else dpy->scratch_length = 0;
	}
	return (dpy->scratch_buffer);
}

/*
 * _XGetHostname - similar to gethostname but allows special processing.
 */
int _XGetHostname (buf, maxlen)
    char *buf;
    int maxlen;
{
    int len;

    buf[0] = '\0';
#ifdef HAVE_GETHOSTNAME
    (void) gethostname (buf, maxlen);
#else
    {
      char *p = getenv ("HOST");
      if (p == NULL) 
	p = "noname";
      strncpy (buf, p, maxlen - 1);
    }
#endif
    buf [maxlen - 1] = '\0';
    len = strlen(buf);
    return len;
}

/* Next 3 functions from xlibint.c, referenced in xinitext.c */

Bool
_XUnknownWireEvent(dpy, re, event)
register Display *dpy;	/* pointer to display structure */
register XEvent *re;	/* pointer to where event should be reformatted */
register xEvent *event;	/* wire protocol event */
{
#ifdef notdef
	(void) fprintf(stderr, 
	    "Xlib: unhandled wire event! event number = %d, display = %x\n.",
			event->u.u.type, dpy);
#endif
	return(False);
}

/*ARGSUSED*/
Status
_XUnknownNativeEvent(dpy, re, event)
register Display *dpy;	/* pointer to display structure */
register XEvent *re;	/* pointer to where event should be reformatted */
register xEvent *event;	/* wire protocol event */
{
#ifdef notdef
	(void) fprintf(stderr, 
 	   "Xlib: unhandled native event! event number = %d, display = %x\n.",
			re->type, dpy);
#endif
	return(0);
}

Bool _XDefaultWireError(display, he, we)
    Display     *display;
    XErrorEvent *he;
    xError      *we;
{
    return True;
}

Bool XQueryExtension(
    register Display *dpy,
    _Xconst char *name,
    int *major_opcode,  /* RETURN */
    int *first_event,   /* RETURN */
    int *first_error)	/* RETURN */
{       
    return False;	/* Extensions not supported */
}

/* Referenced in xlcwarp.c */

#include "Xlcint.h"

XLCd _XlcDefaultLoader(char* name)
{
  return (XLCd) 0;
}
