/* $Id: qutree.c 1.1 1994/02/20 16:59:19 ulrich Exp $ */
/*
 * X library function XQueryTree.
 */
#include "Xlibemu.h"

int
XQueryTree(Display *	dpy,
	   Window	w,
	   Window *	root_return,
	   Window *	parent_return,
	   Window **	children_return,
	   unsigned int * nchildren_return)
{
  Window child, *children;
  int n;

  if (0 == _WCheckWindow (dpy, w, X_QueryTree))
    return 0;
  n = 0;
  for (child = w->bottom_child;
       child != None;
       child = child->lower_sibling) {
    n++;
  }
  children = (Window *) Xmalloc ((n+1) * sizeof (Window));
  n = 0;
  for (child = w->bottom_child;
       child != None;
       child = child->lower_sibling) {
    children[n++] = child;
  }
  *root_return = DefaultRootWindow (dpy);
  *parent_return = w->parent;
  *children_return = children;
  *nchildren_return = n;
  return 1;
}
