/* $Id: raisewi.c 1.1 1994/02/20 17:38:28 ulrich Exp $ */
/*
 * X library function XRaiseWindow.
 */
#include "Xlibemu.h"

int
XRaiseWindow (Display *dpy, Window window)
{
  if (0 == _WCheckWindow (dpy, window, X_ConfigureWindow))
    return 0;
  if (window->upper_sibling) {
    Window parent, sibling;

    parent = window->parent;
    _WTreeDelete (window);
    _WTreeInsertTop (parent, window);
    
    if (window->mapped && window->class == InputOutput) {
      for (sibling = window->lower_sibling;
	   sibling != None;
	   sibling = sibling->lower_sibling) {
	if (! sibling->mapped) continue;
	if (! EXTENTCHECK (&sibling->border_port,
			   &window->border_port)) continue;
	_WSetVisibleRegion (sibling);
	_WSetVisibleSubwindows (sibling);
      }
      _WSetVisibleRegion (window);
      _WSetVisibleSubwindows (window);
      _WDrawWindow (dpy, window, &window->border_port, True);
      _WDrawSubwindows (dpy, window, &window->border_port, True);
    }
  }
  return 1;
}
