/* $Id: setifocu.c 1.2 1994/01/15 02:20:36 ulrich Exp $ */
/*
 * setifocu.c
 *
 * X library functions XSetInputFocus.
 */
#include "Xlibemu.h"

int
XSetInputFocus(dpy, focus, revert_to, time)
    register Display *dpy;
    Window focus;
    int revert_to;
    Time time;
{
  XEvent xe;

  if (time != CurrentTime &&
      (time < _Focus.time || time > _WCurrentTime ()))
    return 0;

  if (focus != None && focus != (Window) PointerRoot) {
    _WCheckWindow (dpy, focus, X_SetInputFocus);
    if (! focus->viewable) {
      _WError (dpy, (XID) focus, BadMatch, X_SetInputFocus);
      return 0;
    }
  }

  if (_Focus.window != None) {
    xe.xfocus.type = FocusOut;
    xe.xfocus.send_event = False;
    xe.xfocus.display = dpy;
    xe.xfocus.window = (_Focus.window == PointerRoot) ? DefaultRootWindow (dpy) : _Focus.window;
    xe.xfocus.mode = NotifyNormal;
    if (_Focus.window == PointerRoot)
      xe.xfocus.detail = NotifyPointer;
    else
      xe.xfocus.detail = NotifyDetailNone;

    _WDispatchEvent (&xe);
  }
  if (focus != None) {
    xe.xfocus.type = FocusIn;
    xe.xfocus.send_event = False;
    xe.xfocus.display = dpy;
    xe.xfocus.window = (focus == PointerRoot) ? DefaultRootWindow (dpy) : focus;
    xe.xfocus.mode = NotifyNormal;
    if (focus == PointerRoot)
      xe.xfocus.detail = NotifyPointer;
    else
      xe.xfocus.detail = NotifyDetailNone;

    _WDispatchEvent (&xe);
  }

  _Focus.window = focus;
  _Focus.revert_to = revert_to;
  _Focus.time = (time == CurrentTime) ? _WCurrentTime() : time;
  return 1;
}
