/* $Id: trcoord.c 1.1 1994/02/20 16:57:00 ulrich Exp $ */
/*
 * X library function XTranslateCoordinates.
 */
#include "Xlibemu.h"

Bool XTranslateCoordinates(
    Display*		dpy,
    Window		src_w,
    Window		dest_w,
    int			src_x,
    int			src_y,
    int*		dest_x_return,
    int*		dest_y_return,
    Window*		child_return)
{
  int root_x, root_y;
  Window child;

  if (0 == _WCheckWindow (dpy, src_w, X_TranslateCoords))
    return 0;
  if (0 == _WCheckWindow (dpy, dest_w, X_TranslateCoords))
    return 0;

  root_x = (int) src_w->window_port.x1 + src_x;
  root_y = (int) src_w->window_port.y1 + src_y;
  child = _WPointToWindow (dpy, root_x, root_y);
  for (; child != None; child = child->parent) {
    if (child->parent == dest_w) break;
  }
  *dest_x_return = root_x - (int) dest_w->window_port.x1;
  *dest_y_return = root_y - (int) dest_w->window_port.y1;
  *child_return  = child;
  return True;
}
