/* $Id: unmapwi.c 1.1 1994/02/20 17:41:40 ulrich Exp $ */
/*
 * X library function XUnmapWindow.
 */
#include "Xlibemu.h"

int
XUnmapWindow (Display* dpy, Window window)
{
  XEvent xe;

  if (0 == _WCheckWindow (dpy, window, X_UnmapWindow))
    return 0;
  if (! window->mapped)
    return 1;

  _WUnmapWindow (dpy, window);

  if (window->event_mask & StructureNotifyMask) {
    xe.xunmap.type = UnmapNotify;
    xe.xunmap.send_event = False;
    xe.xunmap.display = dpy;
    xe.xunmap.event = window;
    xe.xunmap.window = window;
    xe.xunmap.from_configure = False;
    _WDispatchEvent (&xe);
  }
  if (window->parent &&
      window->parent->event_mask & SubstructureNotifyMask) {
    xe.xunmap.type = UnmapNotify;
    xe.xunmap.send_event = False;
    xe.xunmap.display = dpy;
    xe.xunmap.event = window->parent;
    xe.xunmap.window = window;
    xe.xunmap.from_configure = False;
    _WDispatchEvent(&xe);
  }
  return 1;
}
