/* $Id: misc.c 1.2 1994/01/15 02:10:34 ulrich Exp $ */
/*
 * misc.c
 *
 * Miscellaneous X library functions.
 */
#include "Xlibemu.h"

int
XFree (void *ptr)
{
  Xfree (ptr);
  return 0;
}

int
XBell (Display *display, int percent)
{
  extern void sound(), delay();

  sound (1000);
  delay (250);
  sound (0);
  return 0;
}

int XSync(
    Display*		display,
    Bool		discard)
{
  if (discard) {
    XEvent xe;

    while (XPending (display)) {
      XNextEvent (display, &xe);
    }
  }
  return 0;
}

int (*XSynchronize(
    Display*		display,
    Bool		onoff
		   ))()
{ return 0; };

int XSetCloseDownMode(
    Display*		display,
    int			close_mode)
{
  return 0;
}

XVisualInfo *XGetVisualInfo(
    Display*		display,
    long		vinfo_mask,
    XVisualInfo*	vinfo_template,
    int*		nitems_return)
{
  XVisualInfo *vinfo;

  vinfo = (XVisualInfo *) Xcalloc (1, sizeof(XVisualInfo));
  vinfo->screen = 0;
  vinfo->depth = GxScreenDepth ();
  vinfo->class = PseudoColor;
  vinfo->colormap_size = GrNumColors();
  *nitems_return = 1;
  return vinfo;
}

/*
 * This routine can be used to (cheaply) get some memory within a single
 * Xlib routine for scratch space.  It is reallocated from the same place
 * each time, unless the library needs a large scratch space.
 */
char *_XAllocScratch (dpy, nbytes)
	register Display *dpy;
	unsigned long nbytes;
{
	if (nbytes > dpy->scratch_length) {
	    if (dpy->scratch_buffer) Xfree (dpy->scratch_buffer);
	    if (dpy->scratch_buffer = Xmalloc((unsigned) nbytes))
		dpy->scratch_length = nbytes;
	    else dpy->scratch_length = 0;
	}
	return (dpy->scratch_buffer);
}

